/**
 * Rühmatöö kasutajaliides
 * <p>
 * 0: Avaleht
 * 1: Mida soovid teha?
 * 2: Maatriksi nimi
 * 3: Tehte hub
 * 4: Maatriksite vaatamine
 * 5: Kas maatriks üle kirjutada?
 * 6: Maatriksi mõõtmed
 * 7: Maatriksi sisu
 */
package ee.ut.cs.gitlab.maikov;

import ee.ut.cs.gitlab.maikov.expressions.Value;

import java.util.Arrays;
import java.util.Scanner;
import java.util.regex.Pattern;

public class Kasutajaliides {
    /// Konstandid
    // Width
    static final int str_width = 70;

    // Tekst, mida iga küsimuse alguses väljastatakse
    static final String päis =
                    System.lineSeparator().repeat(1)
                    + "-".repeat(str_width)
                    + System.lineSeparator()
                    + "%? - Abi | %A - Algusesse | %L - Lahku"
                    + System.lineSeparator().repeat(0);

    // Tekst, mida abi küsimisel väljastatakse
    static final String abitekst =
                    "Selles programmis on võimalik sooritada erinevaid maatriksitega seotud"
                    + System.lineSeparator()
                    + "tegevusi, sisestades numbreid ja käske."
                    + System.lineSeparator()
                    + "%-Käsud on tähtede suurusest sõltumatud"
                    + System.lineSeparator()
                    + "Käsud, mis algavad '%'-märgiga, on üldiselt asukohast sõltumatud"
                    + System.lineSeparator()
                    + "Üheks erandiks asukoha juures on tehetega seotud käsud nagu %SET"
                    + System.lineSeparator().repeat(2)
                    + "Siin on erinevaid käske, mida on võimalik sooritada"
                    + System.lineSeparator()
                    + "%? - Kuva see menüü"
                    + System.lineSeparator()
                    + "%A - Mine pealehele, kus saab valida jägmiseid tegevusi"
                    + System.lineSeparator()
                    + "%L - Lõpeta koheselt programm"
	            + System.lineSeparator()
                    + "%J - Hüppa kohta programmis"
	            + "%LIST - Väljasta listi olemasolevatest muutujatest";

    // Tutvustus
    static final String tutvustav_tekst = "Tere!"
            + System.lineSeparator()
            + "See siin on maatriksitega tehete programm."
            + System.lineSeparator()
            + "Kui pole kindel, mida teha, kirjuta '%?'";
    // Suvaliste mõõtmetega maatriksi alam- ja ülempiir
    private int[] suva_mõõtmed = {1, 6};

    // Info suvaliste mõõtmete kohta sõnena
    private String suva_mõõtmed_teade() {
        return "> Suvalised mõõtmed "
                + suva_mõõtmed[0]
                + "-"
                + suva_mõõtmed[1]
                + "(S)";
    }

    // Suvaliste elementide alam- ja ülempiir + samm
    private double[] suva_elemendid = {-11, 6, 1};

    // Info suvaliste mõõtmete kohta sõnena
    private String suva_elemendid_teade() {
        return "> Suvalised elemendid "
                + suva_elemendid[0]
                + "-"
                + suva_elemendid[1]
                + " sammuga "
                + suva_elemendid[2]
                + "   (S)";
    }


    // List jaatustest (Mitte tõstutundlik)
    static String[] jaatused = {"jah", "j", "y", "yes"};
    // List eitustest (Mitte tõstutundlik)
    static String[] eitused = {"ei", "e", "n", "no"};

    
    // Sisend
    private Scanner scan;
    // Järgmine leht
    private int next;

    private Vahendaja maatriksid;
    
    // Loodava maatriksi nimi
    private String loodav_nimi;

    // Loodava maatriksi mõõtmed;
    private int[] loodav_mõõtmed = new int[2];
    // Loodava maatriksi elemendid
    private double[] loodav_maatriks;


    public Kasutajaliides() {
        scan = new Scanner(System.in);
        next = 0;
	maatriksid = new Vahendaja();
    }

    /**
     * Klassi tuum. Vaatab, mis on järgmine leht, ja läheb sinna
     * Niimoodi kujundatud selleks, et ei läheks asjad rekursiivseks
     */
    public void küsi(int start) {
        while (true) {
            switch (next) {
                case -1:
                    System.out.println("Head aega!");
                    return;
                case 0:
                    tere();
                    break;
                case 1:
                    algus();
                    break;
                case 2:
                    m_nimi();
                    break;
                case 3:
                    tehted();
                    break;
                case 4:
                    vaata();
                    break;
                case 5:
                    kirjuta_üle_p();
                    break;
                case 6:
                    mõõtmed();
                    break;
                case 7:
                    maatriksi_elemendid();
                    break;
                default:
                    viga();
            }
        }
    }

    /**
     * Kuvab küsimuse
     * Oskab tegeleda käskudega
     */
    private String prompt(String tekst) {
        System.out.println(päis);
        System.out.println(tekst);
        System.out.print("> ");

        String sisend = scan.nextLine();
        String s = sisend.toUpperCase();
        switch (s) {
            case "%?":
                help();
                return "%";    // Ava abi aken
            case "%A":
                next = 1;
                return "%";  // Mine tagasi algusesse
            case "%L":
                next = -1;
                return "%"; // Lahku programmist
            case "%J":
                hüpe();
                return "%";
            case "%LIST":
                teade(next, maatriksid.väärtusedList());
                return "%";
            default:
                return sisend;
        }

    }

    /**
     * Kuvab teate ja läheb kohta järg
     */
    private void teade(int järg, String tekst) {
        String sisend = prompt(tekst + "\n".repeat(3) + "Vajuta ENTER, et jätkata");
        switch (sisend) {
            case "%":
                break;
            default:
                this.next = järg;
        }
    }

    /**
     * Kas sõne on jaatus(1), eitus(0), käsk(-2) või midagi muud(-1)
     */
    private int jaatusP(String str) {
        str = str.toLowerCase();
        if (str.equals("%")) { // Käsk
            return -2;
        } else if (Arrays.asList(jaatused).contains(str)) { // Jaatus
            return 1;
        } else if (Arrays.asList(eitused).contains(str)) { // Eitus
            return 0;
        } else {  // Muu
            return -1;
        }
    }

    /**
     * Tagastab 'true', kui tegu on naturaalarvuga, muidu 'false'
     */
    public boolean naturaalArvP(String a) {
        return Pattern.matches("\\d*", a);
    }

    /**
     * Kas on arv
     */
    public boolean arvP(String a) {
        return Pattern.matches("-?\\d*[.]?\\d*", a);
    }

    /**
     * Tagastab 'true', kui iga sõne on arv.
     */
    public boolean arvudP(String[] arvud) {
        for (String a : arvud) {
            if (!arvP(a)) {
                return false;
            }
        }
        return true;
    }

    /**
     * Tagastab suvalise arvu vahemikust algus,lõpp
     */
    public static double suva_arv(double algus, double lõpp) {
        return (algus + (Math.random() * (lõpp - algus)));
    }

    // Tagastab suvalise arvu vahemikust Algus, lõpp, sammuga samm
    public static double suva_arv(double algus, double lõpp, double samm) {
        return ((int) suva_arv(algus / samm, Math.floor(lõpp / samm) + 1)) * 1;// * aste;
    }

    // Tagastab täisarvu vahemikust algus, lõpp
    public static int suva_arv(int algus, int lõpp) {
        return (int) suva_arv(algus, lõpp, 1);
    }
    

    // LEHED

    /**
     * Väljastab programmi juhendi ja läheb edasi algusesse
     */
    private void tere() {
        teade(1, tutvustav_tekst);
    }

    /**
     * Väljastab infot süsteemi kohta
     * Avaneb, kui kirjutada %?
     */
    private void help() {
        teade(next, abitekst);
    }

    /**
     * Liigub valitud lehele
     */
    private void hüpe() {
        String sisend = prompt("> Mis lehele minna?");
        if (sisend.equals("%")) {
            return;
        } else if (naturaalArvP(sisend)) {
            next = Integer.parseInt(sisend);
        } else {
            teade(next, "> Sisend ei olnud naturaalarv");
            hüpe();
        }

    }

    /**
     * Teatab, et olete sattunud lisamata lehele
     */
    private void viga() {
        teade(1, "Leht " + next
                + " ei ole veel implementeeritud");
    }

    /**
     * Mida soovid järgmisena teha?
     * 1
     */
    private void algus() {
        String sisend = prompt("> Loo uus maatriks(M)"
                + System.lineSeparator()
                + "> Soorita tehe(T)"
                + System.lineSeparator()
                + "> Vaata olemasolevaid maatrikse(V)");
        sisend = sisend.toUpperCase();
        switch (sisend) {
            case "%":
                break;
            case "M":
                next = 2;
                break;
            case "T":
                next = 3;
                break;
            case "V":
                next = 4;
                break;
            default:
                teade(1, "Ebasobiv sõne");    // Algusesse
        }
    }



    /**
     * Küsib loodavale maatriksile nime
     * Kui nimi eksisteerib, küsib, kas asendada
     * 2
     */
    private void m_nimi() {
        String sisend = prompt("> Sisesta loodava maatriksi nimi");
        if (sisend.equals("%")) {
            return;
        }
	
	switch (maatriksid.sobivNimiP(sisend)) {
	case -2:
	    teade(next, "'T' on reserveeritud transponeerimiseks.");
	    break;
	case -1:
	    teade(next, "Nimi peab koosnema vaid tähtedest.");
	    break;
	case 0:
            loodav_nimi = sisend;
            next = 5; // 5: Kas oled kindel?
	    break;
        default:
            loodav_nimi = sisend;
            next = 6; // 6: Maatriksi mõõtmed
        }
    }

    
    /**
     * Sooritab sisendi põhjal tehteid
     * 3
     */
    private void tehted() {
        String sisend =
	    prompt("> Sisesta tehe" + System.lineSeparator()
		   + "| Põhilised tehted on sümbolitega '+', '-', '*', '/'"
		   + System.lineSeparator()
		   + "| Sulud '()' ja tehete järjekord peaksid töötama"
		   + System.lineSeparator()
		   + "| Maatrikseid saab luua kujul {{1,2},{3,4}}"
		   + System.lineSeparator()
		   + "| Astendamine sümboliga '^'"
		   + System.lineSeparator()
		   + "| Maatriksi transponeerimine: m^T"
		   + System.lineSeparator()
		   + "| Maatriksi pöördmaatriks: m^-1"
		   + System.lineSeparator()
		   + "| Ruutmaatriks astmes 0 on sama järgu ühikmaatriks"
		   + System.lineSeparator()
		   + "| %LIST - Annab loetelu olemasolevates nimedest"
		   + System.lineSeparator()
		   + "| %SET <nimi> <tehe> - Seab <nimi> väärtuseks <tehe> tulemuse");
	// Tühi sisend
	if (sisend.trim().equals("")) {
	    return;
	}
	String[] s = sisend.split(" ");
	String tehe = s[0].toUpperCase();
	if (tehe.equals("%")) {
            return;
        } else if (tehe.equals("%SET")) { // Sea väärtuseks
	    if (s.length >= 3){ // On olemas nimi ja võrrand
		maatriksid.väärtusta(s[1], sisend.split(" ", 3)[2]);
	    } else {
		teade(next, "Puudub nimi või võrrand");
	    }
        } else { // Soorita tehe
	    Value tulemus = maatriksid.parse_wrap(sisend);
	    if (tulemus != null){
		System.out.println(tulemus);
	    }
        }
    }

    /**
     * Laseb vaadata olemasolevaid maatrikse
     * 4
     */
    private void vaata() {
        String sisend = prompt("> Sisesta maatriksi nimi, et seda vaadata"
                + System.lineSeparator()
                + "> Sisesta '%LIST', et näha loetelu olemasolevatest maatriksitest");

        if (sisend.equals("%")) {
            return;
        } else if (maatriksid.olemasP(sisend)) {
            // Loob sõne ja lisab maatriksi read
            String väljund = "Nimi: " + sisend + System.lineSeparator();
            väljund += maatriksid.leiaMuutuja(sisend);
            teade(next, väljund);

        } else {
            teade(next, "Maatriksit nimega " + sisend + " ei ole olemas");
        }

    }


    /**
     * Sellenimeline maatriks juba olemas.
     * 5
     */
    private void kirjuta_üle_p() {
        String sisend = prompt("> Maatriks nimega "
                + loodav_nimi
                + " on juba olemas"
                + System.lineSeparator()
                + "> Kirjuta üle? Jah/Ei");
        int vastus = jaatusP(sisend);

        switch (vastus) {
            case -2:
                break; // Käsk
            case 1:
                next = 6;
                break; // Jaatus
            case 0:
                next = 2;
                break; // Eitus
            default:
                teade(next, "Sisend ei olnud jaatus ega eitus");
        }
    }


    /**
     * Küsib maatriksi mõõtmeid
     * Kui vastus on S, valib suvalised
     * 6
     */
    private void mõõtmed() {
        String sisend = prompt("> Sisesta maatriksi mõõtmed formaadis 'm,n'"
                + System.lineSeparator()
                + suva_mõõtmed_teade()).toUpperCase();
        if (sisend.equals("%")) {
            return;
        } else if (sisend.equals("S")) { // Võtab maatriksile suvalised mõõtmed
            loodav_mõõtmed[0] = suva_arv(suva_mõõtmed[0], suva_mõõtmed[1]);
            loodav_mõõtmed[1] = suva_arv(suva_mõõtmed[0], suva_mõõtmed[1]);
        } else { // Kontrollib sisendit
            String[] mõõt_string = sisend.split(",");
	    
	    if (mõõt_string.length == 2){
		int m1;
		int m2;
		if (mõõt_string[0].equals("S")){
		    m1 = suva_arv(suva_mõõtmed[0], suva_mõõtmed[1]);
		} else if (naturaalArvP(mõõt_string[0])){
		    m1 = Integer.parseInt(mõõt_string[0]);
		} else {
		    teade(next, "Sisend ei ole sobivas formaadis");
		    return;
		}
		if (mõõt_string[1].equals("S")){
		    m2 = suva_arv(suva_mõõtmed[0], suva_mõõtmed[1]);
		} else if (naturaalArvP(mõõt_string[1])){
		    m2 = Integer.parseInt(mõõt_string[1]);
		} else {
		    teade(next, "Sisend ei ole sobivas formaadis");
		    return;
		}
                 
                // Muudab mõõtmed
                loodav_mõõtmed[0] = m1;
                loodav_mõõtmed[1] = m2;
                next = 7;
            } else { // Sisend ei sobi
                teade(next, "Sisend ei ole sobivas formaadis");
            }
        }
	
	teade(next,
	      "> Maatriksi mõõtmed on ["
	      + loodav_mõõtmed[0] + ","
	      + loodav_mõõtmed[1] + "]");
    }


    /**
     * Küsib maatriksi elemente ridade kaupa
     * Kui vastus on S, valib suvalised
     * 7
     */
    private void maatriksi_elemendid() {
        loodav_maatriks = new double[loodav_mõõtmed[0] * loodav_mõõtmed[1]];


        String sisend = prompt("| Sisestage maatriks"
                + System.lineSeparator()
                + "| Pärast esimest rida ei ole võimalik käske kasutada"
                + System.lineSeparator()
                + "| Maatriksil on " + loodav_mõõtmed[0]
                + " rida."
                + System.lineSeparator()
                + "| Maatriksil on " + loodav_mõõtmed[1]
                + " veergu."
                + System.lineSeparator()
                + "| 4 veeruga rida oleks vormis n1,n2,n3,n4"
                + System.lineSeparator()
                + suva_elemendid_teade()
        ).toUpperCase();

        if (sisend.equals("%")) {
            return;
        } else if (sisend.equals("S")) { // Võtab maatriksile suvalised mõõtmed

            for (int elt = 0; elt < loodav_mõõtmed[0] * loodav_mõõtmed[1];
                 elt++) {
                loodav_maatriks[elt] = suva_arv(suva_elemendid[0],
                        suva_elemendid[1],
                        suva_elemendid[2]);
            }
        } else { // Sisendi küsimine toimub tsükli lõpus, et
            int rida = 0;
            do {

                String[] mõõt_string = sisend.split(",");

                if (mõõt_string.length == loodav_mõõtmed[1]
                        && arvudP(mõõt_string)) {
                    // Salvestab rea
                    for (int veerg = 0; veerg < loodav_mõõtmed[1]; veerg++) {
                        loodav_maatriks[rida * loodav_mõõtmed[1] + veerg] =
                                Double.parseDouble(mõõt_string[veerg]);
                    }

                    rida++;

                } else { // Sisend ei sobi
                    System.out.println("Sisend ei ole sobivas formaadis. Kirjuta rida uuesti");
                }

                //  Kui pole läbi, küsi veel ridu
                if (rida < loodav_mõõtmed[0]) {
                    System.out.print("> ");
                    sisend = scan.nextLine();
                }
            } while (rida < loodav_mõõtmed[0]);
        }
        maatriksid.lisaMaatriks(loodav_nimi,loodav_mõõtmed,loodav_maatriks);
        teade(1,
                "Maatriks " + loodav_nimi + ": " + System.lineSeparator()
                        + maatriksid.leiaMuutuja(loodav_nimi) + " loodud");


    }

    public static void main(String[] args) {
        Kasutajaliides liides = new Kasutajaliides();

        liides.küsi(0);
    }
}
