package ee.ut.cs.gitlab.maikov.expressions;

import ee.ut.cs.gitlab.maikov.exceptions.InvalidReductionException;

public class AbsoluteValue extends Expression {

    private final Expression expr;

    public AbsoluteValue(Expression expr) {
        if (expr == null) {
            throw new NullPointerException();
        }
        this.expr = expr;
    }

    @Override
    public Expression compute() {
        Expression result = expr.compute();
        if (result instanceof Value value) {
            return value.absoluteValue();
        } else {
            throw new InvalidReductionException();
        }
    }
}
