package ee.ut.cs.gitlab.maikov.expressions;

import ee.ut.cs.gitlab.maikov.exceptions.InvalidReductionException;

public class Addition extends Expression {

    private final Expression left;
    private final Expression right;

    public Addition(Expression left, Expression right) {
        if (left == null || right == null) {
            throw new NullPointerException("Left or right expression is null");
        }
        this.left = left;
        this.right = right;
    }

    @Override
    public Expression compute() {
        Expression left = this.left.compute();
        Expression right = this.right.compute();

        if (left instanceof Value leftValue && right instanceof Value rightValue) {
            return leftValue.addition(rightValue);
        } else {
            throw new InvalidReductionException();
        }
    }
}
