package ee.ut.cs.gitlab.maikov.expressions;

import ee.ut.cs.gitlab.maikov.exceptions.InvalidReductionException;

public class Division extends Expression {
    private final Expression left;
    private final Expression right;

    public Division(Expression left, Expression right) {
        this.left = left;
        this.right = right;
    }

    @Override
    public Expression compute() {
        Expression left = this.left.compute();
        Expression right = this.right.compute();

        if (left instanceof Value leftValue && right instanceof Value rightValue) {
            return leftValue.division(rightValue);
        } else {
            throw new InvalidReductionException();
        }
    }
}
