package ee.ut.cs.gitlab.maikov.expressions;

import ee.ut.cs.gitlab.maikov.exceptions.InvalidMatrixException;
import ee.ut.cs.gitlab.maikov.exceptions.InvalidReductionException;
import ee.ut.cs.gitlab.maikov.matrix.InverseMatrix;
import ee.ut.cs.gitlab.maikov.matrix.Matrix;
import ee.ut.cs.gitlab.maikov.matrix.SquareMatrix;

// Use Exponentiation with negative powers
@Deprecated
public class MatrixInversion extends Expression {
    private final Expression expr;

    public MatrixInversion(Expression expr) {
        if (expr == null) {
            throw new NullPointerException();
        }
        this.expr = expr;
    }

    @Override
    public Expression compute() {
        Expression expr = this.expr.compute();
        if (expr instanceof MatrixValue matrixValue) {
            Matrix matrix = matrixValue.getMatrix();
            if (matrix instanceof SquareMatrix squareMatrix) {
                Matrix inverse = InverseMatrix.compute(squareMatrix);
                return new MatrixValue(inverse);
            } else if (matrix.getRows() == matrix.getCols()) {
                SquareMatrix squareMatrix = new SquareMatrix(matrix.getRows(), matrix.getElements());
                Matrix inverse = InverseMatrix.compute(squareMatrix);
                return new MatrixValue(inverse);
            } else {
                throw new InvalidMatrixException("Matrix value is not a square matrix");
            }
        } else {
            throw new InvalidReductionException();
        }
    }
}
