package ee.ut.cs.gitlab.maikov.expressions;

import ee.ut.cs.gitlab.maikov.exceptions.InvalidReductionException;

public class Subtraction extends Expression {
    private final Expression left;
    private final Expression right;

    public Subtraction(Expression left, Expression right) {
        if (left == null || right == null) {
            throw new NullPointerException();
        }
        this.left = left;
        this.right = right;
    }

    @Override
    public Expression compute() {
        Expression left = this.left.compute();
        Expression right = this.right.compute();

        if (left instanceof Value leftValue && right instanceof Value rightValue) {
            return leftValue.subtraction(rightValue);
        } else {
            throw new InvalidReductionException();
        }
    }
}
