import ee.ut.cs.gitlab.maikov.matrix.InverseMatrix;
import ee.ut.cs.gitlab.maikov.matrix.SquareMatrix;
import org.junit.jupiter.api.Test;

import static org.junit.jupiter.api.Assertions.*;

public class InverseMatrixTest {

    private static final double DELTA = 1e-15;

    @Test
    public void testInverseMatrix1() {
        SquareMatrix matrix = new SquareMatrix(3, new double[] {
                4, 2, 1,
                0,-1, 8,
                4,-5, 9
        });

        SquareMatrix inverse = InverseMatrix.compute(matrix);

        SquareMatrix identity = new SquareMatrix(3);
        identity.identity();

        matrix.multiply(inverse);

        assertArrayEquals(identity.getElements(), matrix.getElements(), DELTA);
    }

    @Test
    public void testInverseMatrix2() {
        SquareMatrix matrix = new SquareMatrix(4, new double[] {
                4, 2, 1,-4,
                0,-1, 8, 9,
                4,-5, 9,-1,
                9, 7, 4, 3
        });

        SquareMatrix inverse = InverseMatrix.compute(matrix);

        SquareMatrix identity = new SquareMatrix(4);
        identity.identity();

        matrix.multiply(inverse);

        assertArrayEquals(identity.getElements(), matrix.getElements(), DELTA);
    }
}
